/*jslint nomen: true, indent: 2, maxerr: 3, maxlen: 80*/
/*global window, RSVP, rJS, jIO*/
(function(window, RSVP, rJS, jIO) {
  "use strict";
  rJS(window)
  
  .declareAcquiredMethod("add_to_index", "add_to_index")
  .declareAcquiredMethod("is_db_empty", "is_db_empty")
  .declareAcquiredMethod("loaded", "loaded")
  .declareAcquiredMethod("all_loaded", "all_loaded")
  
  .allowPublicAcquisition("add", function (page) {
    return this.add_to_index(page[0]);
  })
  .allowPublicAcquisition("add_file", function(file_name){
    return this.loaded(file_name);
  })
  
  .setState({
    to_load: [
      "44_svt.xml", //135 urls
      // "allemandfacile.xml", //650 urls
      // "anglaisfacile.xml", //567 urls
      // "bescherelle.xml", //60 urls
      // "codeacademy.xml", //28 urls
      // "francaisfacile.xml", //1119 urls
      //"hgeo_college.xml", //227 urls
      //"histoirencours.xml", //1415 urls
      //"italienfacile.xml", //1477 urls
      //"jerevise.xml", //918 urls
      // "junior_science_et_vie.xml", //532 urls
      // "kmusic.xml", //107 urls
      // "larousse.xml", //4563 urls
      // //"letudiant.xml", //41649 urls
      // "lewebpedagogique.xml", //298 urls
      // //"livrespourtous.xml", //12061 urls
      // "mathovore.xml", //2221 urls
      // "monanneeaucollege.xml", //121 urls
      // "nosdevoirs.xml", //462 urls
      // "physagreg.xml", //150 urls
      // "physique_chimie_college.xml", //282 urls
      // "reviser_brevet.xml", //229 urls
      // "soutien67.xml", //1604 urls
      // //"superprof.xml", //12296 urls
      // "technologieaucollege27.xml", //129 urls
      // "espagnolfacile.xml", //3352 urls
      // "vivelessvt.xml", //1257 urls
      // // TEST SITEMAPS TO FILL INDEX
      // "20minutes.xml", //2741 urls
      // "independent.xml", //3094 urls
      // "lille.xml", //1742 urls
      // "metronews.xml", //3585 urls
      // "paris.xml", //338 urls
      // "pypi.xml", //6685 urls
      // "theguardian.xml", //5104 urls
      // "linuxfr.xml", //3515 urls
      // "lyon.xml", //3560 urls
      // "lavoixdunord.xml", //3407 urls
      // "python.xml", //2503 urls
      // "reddit.xml", //1563 urls
      // "thesun.xml", //2668 urls
      // "sputniknews.xml", //1581 urls
      // "nytimes.xml", //1604 urls
      // "cnn.xml", //3047 urls
      // "cnbc.xml", //3346 urls
      // "bbc.xml", //2594 urls
      // "vox.xml", //1194 urls
      // "cbsnews.xml", //1260 urls
      // "mirror.xml", //3528 urls
      // "abcnews.xml", //1077 urls
      // "lequipe.xml", //3455 urls
      // "rugbyrama.xml", //1817 urls
      // "elle.xml", //3532 urls
      // "figaro.xml", //2965 urls
      // "lepoint.xml", //3747 urls
      // "telerama.xml", //2593 urls
      // "liberation.xml", //819 urls
      // "lemonde.xml", //3517 urls
      // "leparisien.xml", //2189 urls
      // "latribune.xml" //3190 urls
     ]
  })
  
  .ready(function(){
    var gadget = this;
    return gadget.getDeclaredGadget("parser")
      .push(function(parser_gadget){
        return gadget.changeState({
          parser_gadget : parser_gadget
        });
      });
  })
  
  .declareMethod("init", function(){
    var gadget = this,
        promise_list = [];

    return gadget.all_loaded()
      .push(function(result){
        var i,
          file_path,
          file_name;
        if (result === null){
          for (i = 0; i < gadget.state.to_load.length; i += 1){
            file_path = "../../../crawler_test/" + gadget.state.to_load[i];
            file_name = gadget.state.to_load[i];
            promise_list.push(gadget.load_file(file_path, file_name));
          }
          return RSVP.all(promise_list);
        } else {
          for (i = 0; i < gadget.state.to_load.length; i += 1){
            file_name = gadget.state.to_load[i];
            if (Object.keys(result).indexOf(file_name) < 0){
              file_path = "../../../crawler_test/" + gadget.state.to_load[i];
              promise_list.push(gadget.load_file(file_path, file_name));
            }
          }
          return RSVP.all(promise_list);
        }
      });
    
/*    return gadget.is_db_empty()
      .push(function(empty){
        if (empty) {
          for (var i=0; i<gadget.state.to_load.length; i+=1){
            promise_list.push(gadget.load_file("../../../crawler_test/" + gadget.state.to_load[i]));
          }
          return RSVP.all(promise_list);
        }
      });*/
  })
  
  .declareMethod("load_file", function(file_path, file_name){ //OK
    var gadget = this;
    console.log("loading " + file_path);
    return new RSVP.Queue()
      .push(function(){
        return jIO.util.ajax({url : file_path});
      })
      .push(function(file){
        return gadget.state.parser_gadget.concurrent_parse(file.currentTarget.responseText, file_name);
      })
      .push(undefined, function (my_error) {console.log(my_error)});
  });

}(window, RSVP, rJS, jIO));