/*jslint nomen: true, indent: 2, maxerr: 3, maxlen: 80*/
/*global window, RSVP, rJS, jIO*/
(function (window, document, RSVP, rJS, jIO) {
 "use strict";
 rJS(window)
 
 .ready(function(){
    var index, db;
    
    var index = FlexSearch.create("memory");
    
    db = jIO.createJIO(
      {
          type : "query",
          sub_storage : {
            type : "uuid",
            sub_storage : {
              type : "indexeddb",
              database : "mynij"
            }
          }
      }
    );
    
    this.changeState({
      index : index,
      db : db,
      msgpack : msgpack
    });
    
    return this._load_index();
 })
 
 .declareMethod("get", function(id){
   return this.state.db.get(id);
 })
 
 .declareMethod("get_loaded", function(){
   var gadget = this;
   return this.state.db.get("loaded")
    .push(function(result){
      return result;
    })
    .push(undefined, function (my_error) {return null});
 })
 
 .declareMethod("add_page", function(page_info){ //page_info = {link, title, description, item}
    var gadget = this,
        tmp;
    tmp = page_info;
    tmp.portal_type = "page";
    return gadget.state.db.put(page_info.link, tmp)
      .push(function(){
        var defer = RSVP.defer();
        gadget.state.index.add(page_info.link, page_info.title + " " + page_info.item, defer.resolve.bind(defer));
        return defer.promise;
      })
      .push(function(){
        return gadget._save_index();
      });
 })
 
 .declareMethod("loaded", function(file_name){
   var gadget = this,
      id;
      
    return gadget.state.db.get("loaded")
      .push(function(result){
        var tmp = result;
        tmp[file_name] = true;
        return gadget.state.db.put("loaded", tmp);
      })
      .push(undefined, function (my_error) {
        var tmp = {};
        tmp[file_name] = true;
        return gadget.state.db.put("loaded", tmp);
      });
 })
 
 .declareMethod("_save_index", function(){ //OK
    var serialized = this.state.index.export_test();
    return this.state.db.put("index", serialized);
 })
 
 .declareMethod("search", function(query){
   return this.state.index.search(query);
 })
 
 .declareMethod("_load_index", function(msgpack){ //OK
    var gadget = this;
    return gadget.state.db.get("index")
      .push(function(index){
        gadget.state.index.import_test(index.ids, index.map, index.ctx);
        console.log("index imported from memory");
      })
      .push(undefined, function (my_error) {});
  })
    
  .declareMethod("is_empty", function(){
    return this.state.db.allDocs()
      .push(function(all_docs){
        return all_docs.data.total_rows === 0;
      });
  })
  
  .declareMethod("get_index", function(){
    console.log(this.state.index.info());
    //return this.state.index.export(this.state.msgpack);
    return this.state.index.export_test();
  })
  
  .declareMethod("add_index", function(ids, map, ctx){
    console.log("adding index");
    //this.state.index.import(serialized_index, this.state.msgpack);
    this.state.index.import_test(ids, map, ctx);
    console.log(this.state.index.info());
  });
 
}(window, document, RSVP, rJS, jIO));