(function (window, document, rJS, RSVP) {
  var gadget;
  rJS(window)

  .setState({
    server_model_gadget : null,
    model_gadget : null,
    result_gadget : null,
    loader_gadget : null,
  })
  
  .allowPublicAcquisition("add_to_index", function(page){
    return this.state.model_gadget.add_page(page[0]);
  })
  
  .allowPublicAcquisition("is_db_empty", function(){
    return this.state.model_gadget.is_empty();
  })
  
  .allowPublicAcquisition("loaded", function(file_name){
    return this.state.model_gadget.loaded(file_name);
  })
  
  .allowPublicAcquisition("all_loaded", function(){
    return this.state.model_gadget.get_loaded();
  })

  .ready(function(){
      var model_gadget,
        result_gadget,
        loader_gadget,
        gadget = this;
    
    return gadget.init_buttons()
      .push(function(){
        return gadget.getDeclaredGadget("model");
      })
      .push(function(model){
        model_gadget = model;
      })
      .push(function(){
        return gadget.getDeclaredGadget("result");
      })
      .push(function(result){
        result_gadget = result;
      })
      .push(function(){
        return gadget.getDeclaredGadget("loader");
      })
      .push(function(result){
        return gadget.changeState({
          model_gadget : model_gadget,
          result_gadget : result_gadget,
          loader_gadget : result
        });
      });
  })
  
  .onStateChange(function (modification_dict){
    return this.state.loader_gadget.init();
  })
  
  .declareMethod("init_buttons", function(){
    var event_handler,
      upload_handler,
      i,
      gadget = this;

    event_handler = function(event){
      if (event.target.value === "export"){
        return gadget.state.model_gadget.get_index()
          .push(function(index){
            var zip = new JSZip();
            zip.file("index_ids.mynij", index.ids);
            zip.file("index_map.mynij", index.map);
            zip.file("index_ctx.mynij", index.ctx);
            zip.generateAsync({type : "blob"})
              .then(function(ziped){
                var a = document.createElement('a');
                a.href = URL.createObjectURL(ziped);
                a.download = 'index.zip';
                a.click();      
              });
          });
      }
    };
    
    upload_handler = function(){
      var file = this.files[0],
          reader = new FileReader(),
          zip = new JSZip();
      reader.onload = function(event){
        //return gadget.state.model_gadget.add_index(event.target.result);
        var view = new Uint8Array(event.target.result),
          load = function(file_name){
            return zip.loadAsync(view)
              .then(function(){
                return zip.file(file_name).async("string");
              })
              .then(function(data){
                return data;
              });
          },
          promises = [];
          promises.push(load("index_ids.mynij"));
          promises.push(load("index_map.mynij"));
          promises.push(load("index_ctx.mynij"));
          Promise.all(promises)
            .then(function(result){
              return gadget.state.model_gadget.add_index(result[0], result[1], result[2]);
            });
      };
      //reader.readAsText(file);
      reader.readAsArrayBuffer(file);
    };
    
    document.getElementById("export").addEventListener("click", event_handler);
    document.getElementById("import").addEventListener("change", upload_handler);
  })
 
  .declareMethod("search", function (key){
    var gadget = this;
    return gadget.state.result_gadget.clear()
      .push(function(){
        console.log("starting search");
        return gadget.state.model_gadget.search(key);
      })
      .push(function(result){
        console.log("search done");
        if (result.length === 0) {
            return gadget.state.result_gadget.addItem({
              title : "No results found",
              link : ""
            }, "");
        } else {
          var i, promise_list = [];
          for (i=0; i<result.length; i+=1){
            promise_list.push(gadget.state.model_gadget.get(result[i]));
          }
          return new RSVP.Queue()
            .push(function(){
              return RSVP.all(promise_list);
            })
            .push(function(result){
              var i, promise_list = [];
              for (i=0; i<result.length; i+=1){
                promise_list.push(gadget.state.result_gadget.addItem(result[i], key));
              }
            });
        }
      });
  })
  
  .declareMethod("add_searx_results", function(key){
    var gadget = this;
    return new RSVP.Queue()
      .push(function(){
        return jIO.util.ajax({url : "https://cors-anywhere.herokuapp.com/search.disroot.org/?q=" + key + "&category_general=on&theme=oscar&language=fr"});
      })
      .push(function(resultHTML){
        var i,
            promise_list = [],
            elements,
            doc = new DOMParser().parseFromString(resultHTML.currentTarget.response, "text/html");
        elements = doc.body.querySelectorAll('div.result.result-default');
        for (i=0; i<elements.length; i+=1){
          promise_list.push(gadget.state.result_gadget.show_searx_result(elements[i], key));
        }
        return RSVP.all(promise_list);
      });
  })

  .onEvent("submit", function(event){
    var gadget = this;
    return gadget.search(event.target.elements[0].value)
      .push(function(){
        return gadget.add_searx_results(event.target.elements[0].value);
      });
  });

}(window, document, rJS, RSVP));
